<?php

namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use App\Images;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class CompanyController extends Controller
{
    public function index(Request $request){                
        return view('settings.company.index', [
            'countries' => countries()
        ]);
    }

    public function store_coordonnee(Request $request){                
        $request->validate([
            'name' => 'required',
            'type' => 'required',
        ]);

        $this->store($request->all());

        return redirect()->back()->with('success', 'success');
    }

    public function store_info(Request $request){
        $request->validate([
            'address' => 'required',
            'postcode' => 'required',
            'city' => 'required',
            'phone_num' => 'required',
        ]);

        $this->store($request->all());
        
        return redirect()->back()->with('success', 'success');
    }

    private function store($data = []){        
        foreach ($data as $key => $item) {
            DB::table('settings')->where('name', "company_{$key}")->update([
                'value' => is_null($item) ? '' : $item,
                'updated_at' => date_now()
            ]);
        }
    }

    public function upload_logo(Request $request){
        $folder = "images/logo";
        $image = $request->image;

        if($image->isValid()){
            $images = new Images($folder);
            $rep = $images->image_upload($image, ["width" => "250px", "height" => "250px"]);
            DB::table('settings')->where('name', "company_logo")->update([
                'value' => $rep['filename'],
                'updated_at' => date_now()
            ]);

            return redirect()->back()->with('success', 'success');
        }
    }

    public function numerotation(Request $request){
        $desc = $request->description; 
        DB::table('numerotation')->where('description', $desc)->update([
            "format" => $request->format,
            "begin_num" => $request->debut,
            'updated_at' => date_now()
        ]);
        return redirect()->back()->with('success', 'success');
    }
}
