<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('products_hs', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('product_id');
            $table->unsignedBigInteger('location_id')->nullable();
            $table->unsignedBigInteger('motif_id')->nullable();
            $table->string('product');
            $table->string('location');
            $table->text('motif');
            $table->double('qty')->default(0);
            $table->unsignedBigInteger('user_id')->nullable();
            $table->string('user')->nullable();
            $table->foreign('product_id')->on('products')->references('id')->onDelete('cascade');
            $table->foreign('location_id')->on('locations')->references('id')->onDelete('set null');
            $table->foreign('user_id')->on('users')->references('id')->onDelete('set null');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('products_hs');
    }
};
