import PrimeVue from 'primevue/config';
import Aura from '@primevue/themes/aura';
import { ZiggyVue } from '../../../../vendor/tightenco/ziggy/dist';

import { createApp } from 'vue';
import List from './components/List.vue';
import Create from './components/Create.vue';
import Detail from './components/Detail.vue';
import Setting from './components/Setting.vue';

const app = createApp({});

app
    .use(ZiggyVue)
    .use(PrimeVue, {
        ripple: true,
        theme: {
            preset: Aura
        }
    });

app.component('List', List);
app.component('Create', Create);
app.component('Detail', Detail);
app.component('Setting', Setting);

app.mount('#crm');
