<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('commandes', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('customer_id')->nullable();
            $table->unsignedBigInteger('user_id')->nullable();
            $table->string("customer")->nullable();
            $table->string("customer_reference")->nullable();
            $table->string("customer_address")->nullable();
            $table->string("customer_phone")->nullable();
            $table->string("username")->nullable();
            $table->string("reference")->nullable();
            $table->bigInteger("numero")->default(0);
            $table->double("price_total")->default(0);
            $table->datetime("deleted_at")->nullable();
            $table->foreign('customer_id')->on('customers')->references('id')->onDelete('set null');
            $table->foreign('user_id')->on('users')->references('id')->onDelete('set null');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('commandes');
    }
};
