<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::table('products', function (Blueprint $table) {            
            $table->string('title');
            $table->string('reference')->unique();
            $table->string('numero')->unique();
            $table->string('barcode')->nullable();
            $table->string('image');
            $table->enum('status', ['inactive', 'active'])->default('active');            
            $table->text('description')->nullable();
            $table->unsignedBigInteger('unite_id')->nullable();
            $table->string('unite');
            $table->unsignedBigInteger('user_id')->nullable();
            $table->string('username');
            $table->boolean('stock_management')->default(0);
            $table->boolean('is_tva_inclusive')->default(0);
            $table->double('purchase_price')->default(0);
            $table->double('tva_rate')->default(0);
            $table->double('price')->default(0);
            $table->date('expiration_date')->nullable();
            $table->double('reorder_level')->default(0);
            $table->bigInteger('position')->default(0);
            $table->string('background')->default('#FFFFFF');
            $table->string('color')->default('#000000');
            $table->string('slug');

            // Définir les clés étrangères
            $table->foreign('user_id')->references('id')->on('users')->onDelete('set null');
            $table->foreign('unite_id')->references('id')->on('unites')->onDelete('set null');
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::table('products', function (Blueprint $table) {
            //
        });
    }
};
