<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('invoices_details', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('invoice_id')->nullable();
            $table->enum('row_type', ['product', 'sous-total', 'saut-page', 'texte', 'title']);
            $table->unsignedBigInteger('product_id')->nullable();
            $table->string('product');
            $table->double('qty');
            $table->unsignedBigInteger('unite_id')->nullable();
            $table->string('unite');
            $table->double('price_ht')->default(0);            
            $table->enum('discount_by', ['percent', 'amount'])->nullable();
            $table->double('discount_rate')->default(0);
            $table->double('discount_price')->default(0);
            $table->double('tva_rate')->default(0);
            $table->double('tva_price')->default(0);
            $table->double('price_ttc')->default(0);
            $table->foreign('invoice_id')->on('invoices')->references('id')->onDelete('set null');
            $table->foreign('product_id')->on('products')->references('id')->onDelete('set null');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('invoices_details');
    }
};
