<?php

return [
    "app" => [
        "dashboard" => [
            "label" => "Tableau de bord",
            "name" => "dashboard",
            "icon" => "bi bi-speedometer text-2xl",
            "active" => false,
            "route" => "app.dashboard",
            "params" => []
        ],
        "receipt" => [
            "label" => "Caisses et ventes",
            "name" => "receipt",
            "active" => false,
            "icon" => "bi bi-pc-display-horizontal text-2xl",
            "route" => "",
            "params" => [],
        ],
        "crm" => [
            "label" => "CRM",
            "name" => "crm",
            "active" => false,
            "icon" => "bi bi-person-vcard text-2xl",
            "child" => [
                "customer" => [
                    "label" => "Clients",
                    "name" => "customer",
                    "active" => false,
                    "icon" => "bi bi-person-circle",
                    "route" => "app.crm.index",
                    "params" => ['type' => 'customers'],
                ],
                "supplier" => [
                    "label" => "Fournisseurs",
                    "name" => "supplier",
                    "active" => false,
                    "icon" => "bi bi-person-lines-fill",
                    "route" => "app.crm.index",
                    "params" => ['type' => 'supplier'],
                ],
            ]
        ],
        "catalog" => [
            "label" => "Catalogues",
            "name" => "catalog",
            "active" => false,
            "icon" => "bi bi-boxes text-2xl",
            "child" => [
                "category" => [
                    "label" => "Catégories",
                    "name" => "category",
                    "icon" => "bi bi-inboxes",
                    "active" => false,
                    "route" => "app.catalogs.category.index",
                    "params" => []
                ],
                "product" => [
                    "label" => "Produits",
                    "name" => "product",
                    "icon" => "bi bi-box2",
                    "active" => false,
                    "route" => "app.catalogs.product.index",
                    "params" => []
                ]
            ],
        ],
        "sales" => [
            "label" => "Gestion des ventes",
            "name" => "sales",
            "active" => false,
            "icon" => "bi bi-cash-coin",
            "child" => [
                "invoice" => [
                    "label" => "Factures",
                    "name" => "invoice",
                    "active" => false,
                    "icon" => "bi bi-journal-check",
                    "route" => "",
                    "params" => [],
                ],
                "credit" => [
                    "label" => "Avoirs",
                    "name" => "credit",
                    "active" => false,
                    "icon" => "bi bi-journal-x",
                    "route" => "",
                    "params" => [],
                ],
                "order" => [
                    "label" => "Bon de commandes",
                    "name" => "order",
                    "active" => false,
                    "icon" => "bi bi-journal-medical",
                    "route" => "",
                    "params" => [],
                ],
                "retour" => [
                    "label" => "Bon de retours",
                    "name" => "retour",
                    "active" => false,
                    "icon" => "bi bi-journal-arrow-up",
                    "route" => "",
                    "params" => [],
                ],
            ]
        ],        
        "purchase" => [
            "label" => "Gestion des achats",
            "name" => "purchase",
            "active" => false,
            "icon" => "bi bi-basket3",
            "child" => [
                "invoice" => [
                    "label" => "Factures",
                    "name" => "invoice",
                    "active" => false,
                    "icon" => "bi bi-journal-check",
                    "route" => "",
                    "params" => [],
                ],
                "credit" => [
                    "label" => "Avoirs",
                    "name" => "credit",
                    "active" => false,
                    "icon" => "bi bi-journal-x",
                    "route" => "",
                    "params" => [],
                ],
                "order" => [
                    "label" => "Bon de commandes",
                    "name" => "order",
                    "active" => false,
                    "icon" => "bi bi-journal-medical",
                    "route" => "",
                    "params" => [],
                ],
                "retour" => [
                    "label" => "Bon de retours",
                    "name" => "retour",
                    "active" => false,
                    "icon" => "bi bi-journal-arrow-up",
                    "route" => "",
                    "params" => [],
                ],
            ]
        ], 
        "stock" => [
            "label" => "Gestion des stocks",
            "name" => "stock",
            "active" => false,
            "icon" => "bi bi-arrow-left-right",
            "child" => [
                "inventory" => [
                    "label" => "Inventaires",
                    "name" => "inventory",
                    "active" => false,
                    "icon" => "bi bi-plus-slash-minus",
                    "route" => "",
                    "params" => [],
                ],
                "appro" => [
                    "label" => "Approvisionnements",
                    "name" => "appro",
                    "active" => false,
                    "icon" => "bi bi-folder-plus",
                    "route" => "",
                    "params" => [],
                ],
                "transfert" => [
                    "label" => "Transfert de stock",
                    "name" => "transfert",
                    "active" => false,
                    "icon" => "bi bi-arrows-expand-vertical",
                    "route" => "",
                    "params" => [],
                ],
            ]
        ],        
        "bank" => [
            "label" => "Banques et Trésorie",
            "name" => "bank",
            "active" => false,
            "icon" => "bi bi-piggy-bank text-2xl",
            "route" => "",
            "params" => [],
        ],
        "location" => [
            "label" => "Sites",
            "name" => "location",
            "active" => false,
            "icon" => "bi bi-houses text-2xl",
            "route" => "",
            "params" => [],
        ],
        "settings" => [
            "label" => "Administrateur",
            "name" => "settings",
            "icon" => "bi bi-gear text-2xl",
            "active" => false,
            "child" => [
                "product" => [
                    "label" => "Produits",
                    "name" => "product",
                    "icon" => "bi bi-boxes text-lg",
                    "active" => false,
                    "route" => "app.settings.teams.users.index",
                    "params" => [],
                ],
                "invoice" => [
                    "label" => "Factures",
                    "name" => "invoice",
                    "active" => false,
                    "icon" => "bi bi-journal-check",
                    "route" => "",
                    "params" => [],
                ],
                "credit" => [
                    "label" => "Avoirs",
                    "name" => "credit",
                    "active" => false,
                    "icon" => "bi bi-journal-x",
                    "route" => "",
                    "params" => [],
                ],
                "order" => [
                    "label" => "Bon de commandes",
                    "name" => "order",
                    "active" => false,
                    "icon" => "bi bi-journal-medical",
                    "route" => "",
                    "params" => [],
                ],
                "retour" => [
                    "label" => "Bon de retours",
                    "name" => "retour",
                    "active" => false,
                    "icon" => "bi bi-journal-arrow-up",
                    "route" => "",
                    "params" => [],
                ],
                "users" => [
                    "label" => "Equipes",
                    "name" => "users",
                    "icon" => "bi bi-people ",
                    "active" => false,
                    "route" => "app.settings.teams.users.index",
                    "params" => [],
                ],
                "backup" => [
                    "label" => "Sauvegarde/Restauration",
                    "name" => "backup",
                    "icon" => "bi bi-database-down",
                    "active" => false,
                    "route" => "",
                    "params" => [],
                ],
                "company" => [
                    "label" => "Mon entreprise",
                    "name" => "company",
                    "icon" => "bi bi-building-gear",
                    "active" => false,
                    "route" => "app.settings.company.index",
                    "params" => [],
                ],
            ],
        ]
    ]
];
