<?php
 
 namespace modules\catalogs\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use modules\location\Models\Location;

class ProductLocation extends Model
{
    use HasFactory;

    protected $table = "products_locations";
    protected $fillable = [
        'product_id',
        'location_id', 
        'location_type',        
        'description', 
        'position', #
        'background', #
        'color', #
        'price_variant',
        'cost_price', # //prix de revient
        'cmup', #
        'frns_id', #
        'frns', #
        'frns_is_tva_inclusive', #
        'frns_tva', #
        'frns_price', #
        'purchase_price', # //prix d'achat
        'is_tva_inclusive',
        'tva_rate',
        'status', 
        'reorder_level',        
        'delivery_status',
        'delivery_price',
    ];

    public function product()
    {
        return $this->belongsTo(Products::class, 'product_id', 'id');
    }

    public function location()
    {
        return $this->belongsTo(Location::class, 'location_id');
    }

    public function sublocation(){
        return $this->belongsTo(ProductSubLocation::class, 'product_location_id');
    }

    public function productStock()
    {
        return $this->hasOne(ProductStock::class, 'location_id', 'location_id');
    }

    // Si la relation entre ProductLocation et ProductCustomerPrice existe
    public function customerPrices()
    {
        return $this->hasMany(ProductCustomerPrice::class, 'location_id', 'location_id');
    }
}
