import PrimeVue from 'primevue/config';
import Aura from '@primeuix/themes/aura';
import { ZiggyVue } from '../../../../vendor/tightenco/ziggy/dist';

import { createApp } from 'vue';
import List from './components/List.vue';
import Create from './components/Create.vue';
import Detail from './components/Detail.vue';
import Setting from './components/Setting.vue';

const app = createApp({});

app
    .use(ZiggyVue)
    .use(PrimeVue, {
        ripple: true,
        theme: {
            preset: Aura
        }
    });

const appContainer = document.querySelector('.app-container');
const appId = appContainer.getAttribute('app');

const components = {
    'list': () => import('./components/List.vue'),
    'create': () => import('./components/Create.vue'),
    'detail': () => import('./components/Detail.vue'),
    'document': () => import('./components/Document.vue'),
    'releve': () => import('./components/Releve.vue'),

    'setting': () => import('./components/Setting.vue'),
}

if (components[appId]) {
    components[appId]().then(({ default: component }) => {
        app.component(appId.replace(/-/g, ''), component).mount(`#crm`);
    });
} else {
    app.mount("#app");
}
