<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('caisses_users', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('caisse_status_id')->nullable(); // Match with `caisses.id`            
            $table->unsignedBigInteger('user_id')->nullable(); // Match with `users.id`
            $table->string('user')->nullable();
            $table->double('amount_start')->default(0);
            $table->double('amount_closed')->default(0);
            $table->foreign('caisse_status_id')->references('id')->on('caisses_status')->onDelete('set null');
            $table->foreign('user_id')->references('id')->on('users')->onDelete('set null');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('caisses_users');
    }
};
