<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('carts_details', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('cart_id')->nullable();
            $table->unsignedBigInteger('product_id')->nullable();
            $table->string('product_title')->nullable();
            $table->unsignedBigInteger('product_id_out')->nullable();
            $table->string('product_out_title')->nullable();
            $table->double('qty')->default(0);
            $table->double('stock_out')->default(0);
            $table->double('product_stock')->default(0);
            $table->double('price')->default(0);
            $table->double('tva')->default(0);
            $table->double('tva_price')->default(0);
            $table->enum('discount_by', ['percent', 'price'])->default('percent');
            $table->enum('discount_of', ['price_unit', 'price_total'])->nullable();
            $table->enum('discount_type', ['product', 'offered'])->nullable();
            $table->double('discount')->default(0);
            $table->double('discount_price')->default(0);
            $table->double('total_price_ht')->default(0);
            $table->double('total_price_ttc')->default(0);            
            $table->double('delivery_price')->default(0);
            $table->double('delivery_price_total')->default(0);
            $table->foreign('cart_id')->on("carts")->references('id')->onDelete("set null");
            $table->foreign('product_id')->on("products")->references('id')->onDelete("set null");
            $table->foreign('product_id_out')->on("products")->references('id')->onDelete("set null");
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('carts_details');
    }
};
