<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('payment_methods', function (Blueprint $table) {
            $table->id();
            $table->string('title');
            $table->enum('type', ['cash', 'mobile-banking', 'bank-check', 'bank-transfer', 'exchange-service']);
            $table->string('icon')->nullable();
            $table->longText('additionnal')->nullable();
            $table->boolean('is_default')->default(false);
            $table->boolean('deposit_to_cashbox')->default(false);
            $table->string('slug')->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('payment_methods');
    }
};
