<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create("accounting_documents_payments", function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger("accounting_document_id")->nullable();
            $table->string("reference")->nullable();
            
            $table->unsignedBigInteger("user_id")->nullable();
            $table->string("username")->nullable();

            $table->unsignedBigInteger("payment_method_id")->nullable();
            $table->string("payment_method")->nullable();

            $table->double("amount")->default(0);

            $table->text("observation")->nullable();

            $table->foreign("accounting_document_id")->on("accounting_documents")->references("id")->onDelete("set null");
            $table->foreign("user_id")->on("users")->references("id")->onDelete("set null");
            $table->foreign("payment_method_id")->on("payment_methods")->references("id")->onDelete("set null");
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists("accounting_documents_payments");
    }
};
