import PrimeVue from 'primevue/config';
import Aura from '@primeuix/themes/aura';
import { ZiggyVue } from '../../../../vendor/tightenco/ziggy/dist';
import { createApp } from 'vue';

const app = createApp({});

app.use(ZiggyVue)
    .use(PrimeVue, {
        ripple: true,
        theme: {
            preset: Aura
        }
    });

const appContainer = document.querySelector('.app-container');
const appId = appContainer.getAttribute('app');

const components = {
    'list-receipt': () => import('./components/Receipt/List.vue'),
    'detail-receipt': () => import('./components/Receipt/Detail.vue'),
    'receipt': () => import('./components/Receipt/Receipt.vue'),
    'caisse-open': () => import('./components/Receipt/CaisseOpen.vue'),

    'list-document': () => import('./components/Documents/List.vue'),
    'detail-document': () => import('./components/Documents/Detail.vue'),    
    'payment-document': () => import('./components/Documents/Payments.vue'),
    'story-document': () => import('./components/Documents/Stories.vue'),

    'setting': () => import('./components/Setting.vue'),
}

if (components[appId]) {
    components[appId]().then(({ default: component }) => {
        app.component(appId.replace(/-/g, ''), component).mount(`#sales`);
    });
} else {
    app.mount("#app");
}