<x-guest-layout>
    
    <h3 class="text-3xl font-bold mt-8 text-primary">Bonjour,</h3>
    <p>Saisissez vos informations de connexion pour accéder à votre espace utilisateur.</p>

    @error("email")
    <div class="flex items-center p-4 my-4 text-sm text-red-800 border border-red-300 rounded-lg bg-red-50 dark:bg-gray-800 dark:text-red-400 dark:border-red-800" role="alert">
        <svg class="flex-shrink-0 inline w-4 h-4 me-3" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="currentColor" viewBox="0 0 20 20">
          <path d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5ZM9.5 4a1.5 1.5 0 1 1 0 3 1.5 1.5 0 0 1 0-3ZM12 15H8a1 1 0 0 1 0-2h1v-3H8a1 1 0 0 1 0-2h2a1 1 0 0 1 1 1v4h1a1 1 0 0 1 0 2Z"/>
        </svg>
        <span class="sr-only">Info</span>
        <div>
            <x-input-error :messages="$errors->get('email')" class="mt-2" />
        </div>
    </div>
    @enderror

    <!-- Session Status -->
    

    <form class="mt-4 form" method="POST" action="{{ route('app.login.process') }}">
        @csrf

        <!-- Email Address -->
        <div>
            <x-input-label for="email" :value="__('Email')" />
            <x-text-input id="email" class="block mt-1 w-full" type="email" name="email" :value="old('email')" required autofocus autocomplete="username" />            
        </div>

        <!-- Password -->
        <div class="mt-4">
            <x-input-label for="password" value="Mot de passe" />

            <x-text-input id="password" class="block mt-1 w-full"
                            type="password"
                            name="password"
                            required autocomplete="current-password" />

            <x-input-error :messages="$errors->get('password')" class="mt-2" />
        </div>

        <!-- Remember Me -->
        {{-- <div class="block mt-4">
            <label for="remember_me" class="inline-flex items-center">
                <input id="remember_me" type="checkbox" class="rounded border-gray-300 text-indigo-600 shadow-sm focus:ring-indigo-500" name="remember">
                <span class="ms-2 text-sm text-gray-600">{{ __('Remember me') }}</span>
            </label>
        </div> --}}

        <div class="flex flex-col items-center justify-end mt-4">
            <x-primary-button class="bg-primary btn-submit text-white h-12 uppercase border border-blue-800">
                <span class="!text-md">se connécter</span>
            </x-primary-button>

            <a class="underline text-sm text-gray-600 hover:text-gray-900 rounded-md focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500" href="">
                Mot de passe oublié
            </a>

            
        </div>
    </form>

    <script>
        const form = document.querySelector(".form");
        const btn = document.querySelector(".btn-submit");

        form.addEventListener("submit", function(e){
            btn.setAttribute("disabled", "");
            btn.textContent = "Connexion en cours...";
        });
    </script>
</x-guest-layout>