<div class="overflow-y-auto py-5 px-3 h-full bg-white ">
    <div class="flex items-center justify-between w-full">
        <a href="{{route('app.dashboard')}}" class="">
            <img src="{{asset('images/logo/default-logo.png')}}" alt="" class="h-10">
        </a>
    </div>

    <ul class="space-y-2 mt-3 pt-3">        
        @foreach (menus('app')['data'] as $k => $menu)        
            <li>
                @if(!isset($menu['child']))
                    <a
                        href="{{$menu['route'] == '' ? '' : route($menu['route'], $menu['params'])}}"
                        class="flex items-center p-2 text-base group hover:bg-gray-100 hover:rounded-md @if($menu['active']) bg-primary rounded-md @endif"                    
                    >
                    <i class="text-2xl @if($menu['active']) text-white @else text-gray-900 @endif {{$menu['icon']}}"></i>
                    <span 
                        class="ml-3 text-sm @if($menu['active']) text-white @else text-gray-900 @endif '"
                    >{{ $menu['label'] }}</span>
                </a>
                @else
                    <button
                        type="button"
                        class="@if($menu['active']) bg-primary rounded-md @else hover:bg-gray-100 hover:rounded-md @endif flex items-center p-2 w-full text-base transition duration-75 group"
                        aria-controls="dropdown-{{ $menu['name'] }}"
                        data-collapse-toggle="dropdown-{{ $menu['name'] }}"
                        aria-expanded="{{$menu['active']}}"
                    >
                        <i class="text-2xl @if($menu['active']) text-white @else text-gray-900 @endif {{$menu['icon']}}"></i>
                        <span 
                            class="@if($menu['active']) text-white @else text-gray-900 @endif flex-1 ml-3 text-left whitespace-nowrap text-sm  "
                        >{{ $menu['label'] }}</span>
                        <i 
                            class="bi bi-chevron-down @if($menu['active']) text-white @else text-gray-900 @endif"
                        ></i>
                    </button>
                    <ul
                        id="dropdown-{{ $menu['name'] }}" 
                        class="py-2 space-y-1 @if(!$menu['active']) hidden @endif"
                    >
                        <li>
                            @foreach ($menu['child'] as $child)
                                <a
                                    href="{{(isset($child['route']) && $child['route']) == '' ? '' : route($child['route'], $child['params'])}}"
                                    class="flex items-center pe-2 py-1.5 pl-4 w-full text-base font-medium text-gray-900 transition duration-75 group"
                                >
                                    <i class="text-xl @if($child['active']) text-primary @else text-gray-900 @endif {{$child['icon'] ?? ''}}"></i>                                     
                                    <span class="ms-2 text-sm @if($child['active']) border-b-2 border-primary text-primary font-bold @endif">{{ $child['label'] ?? '' }}</span>
                                </a>  
                            @endforeach
                        </li>
                    </ul>
                @endif
            </li>
        @endforeach
    </ul>
</div>