<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('caisses_stories', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('caisse_status_id')->nullable(); // Match with `caisses.id`            
            $table->unsignedBigInteger('customer_id')->nullable(); // Match with `users.id`
            $table->string('customer')->nullable();
            $table->unsignedBigInteger('user_id')->nullable(); // Match with `users.id`
            $table->string('user')->nullable();
            $table->text('description')->nullable();
            $table->double('amount_in')->default(0);
            $table->double('amount_out')->default(0);
            $table->double('sold')->default(0);
            $table->date('date_action');
            $table->string('token')->nullable();
            $table->string('rap_token')->nullable();
            $table->foreign('caisse_status_id')->references('id')->on('caisses_status')->onDelete('set null');
            $table->foreign('customer_id')->references('id')->on('business_contacts')->onDelete('set null');
            $table->foreign('user_id')->references('id')->on('users')->onDelete('set null');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('caisses_stories');
    }
};
