<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('appros_details', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger("product_id")->nullable();
            $table->string('product_reference');
            $table->string('product_title');
            $table->double('frns_price')->default(0);
            $table->double('stock_in')->default(0);
            $table->double('stock_actual')->default(0);
            $table->double('stock_final')->default(0);
            $table->unsignedBigInteger('unite_id')->nullable();
            $table->string('unite');
            $table->integer('row_index')->default(0);
            $table->string('token');
            $table->foreign('unite_id')->references('id')->on('unites')->onDelete('set null');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('appros_details');
    }
};
