<!DOCTYPE html>
<html lang="<?php echo e(str_replace('_', '-', app()->getLocale())); ?>">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="<?php echo e(csrf_token()); ?>">

        <title><?php echo e(config('app.name', 'Laravel')); ?> <?php echo $__env->yieldContent("title"); ?></title>                     
            
        <?php echo app('Illuminate\Foundation\Vite')(['resources/js/app.js']); ?>

        <?php echo $__env->yieldPushContent("styles"); ?>
    </head>

    <body class="font-sans text-gray-900">
        <?php echo app('Tighten\Ziggy\BladeRouteGenerator')->generate(); ?>

        <div class="antialiased bg-gray-50 " id="app">
            <nav class="navbar bg-white border-b border-gray-200 px-4 py-2.5 fixed left-0 right-0 top-0 z-20">
                <?php echo $__env->make('partials.navbar', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
            </nav>

            <aside
                class="sidebar fixed top-0 left-0 z-40 w-64 h-screen transition-transform -translate-x-full bg-white border-r border-gray-200 md:translate-x-0"
                aria-label="Sidenav"
                id="drawer-navigation"
            >
                <?php echo $__env->make('partials.sidebar', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
            </aside>
            
            <main class="px-2 pb-4 md:px-4 md:ml-64 h-auto pt-16">
                
                
                <?php if(!is_null(menus('app')['active'])): ?>
                <div class="flex items-center">
                    <div class="mr-4">
                        <div class="text-primary">
                            <i class="text-2xl <?php echo e(menus('app')['active']['icon']); ?>"></i>
                        </div>
                    </div>
                    <div>
                        <p class="font20 uppercase font-bold text-primary">
                            <?php echo e(menus('app')['active']['label']); ?>

                            <?php if(isset(menus('app')['active']['child']) && menus('app')['active']['child']): ?>
                            
                            / <?php echo e(menus('app')['active']['child'][menus('app')['module']]['label']); ?>

                            <?php endif; ?>
                        </p>
                    </div>
                </div>
                <?php endif; ?>

                <?php echo $__env->yieldContent("content"); ?>
            </main>            
        </div>


        <?php echo $__env->yieldPushContent("scripts"); ?>

    </body>
    
</html><?php /**PATH D:\SERVER\letbmitsinjo\resources\views/layouts/app.blade.php ENDPATH**/ ?>